--- /usr/bin/debdiff	2009-02-11 08:41:58.000000000 +0000
+++ debdiff	2009-04-27 17:28:29.097401000 +0000
@@ -528,6 +528,14 @@
 	# Execute diff and remove the common prefixes $dir1/$dir2, so the patch can be used with -p1,
 	# as if when interdiff would have been used:
 	system(join(" ", @command)) || fatal "Failed to execute @command!";
+	if ($? & 127) {
+	    fatal sprintf("@command exited due to signal %d.", $? & 127);
+	}
+	# We include == 2, since diff(1) returns "failure" when
+	# encountering binary files that differ.
+	elsif ($? >> 8 == 1 || $? >> 8 == 2) {
+	    $exit_status = 1;
+	}
 
 	if ($have_diffstat and $show_diffstat) {
 	    print "diffstat for $sdir1 $sdir2\n\n";
@@ -547,7 +555,7 @@
 	close DIFF;
     }
 
-    exit 0;
+    exit $exit_status;
 }
 else {
     fatal "Internal error: \$type = $type unrecognised";
